Index: trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 72101)
+++ trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 72102)
@@ -520,5 +520,4 @@
 	src/selector/graphics/details/UIGDetailsElements.h \
 	src/selector/graphics/details/UIGMachinePreview.h \
-	src/settings/UISettingsSelector.h \
 	src/settings/UISettingsSerializer.h \
 	src/settings/global/UIGlobalSettingsExtension.h \
@@ -664,4 +663,5 @@
 	src/settings/UISettingsDialogSpecific.h \
 	src/settings/UISettingsPage.h \
+	src/settings/UISettingsSelector.h \
 	src/widgets/UIAddDiskEncryptionPasswordDialog.h \
 	src/widgets/UIBootTable.h \
@@ -780,4 +780,5 @@
 	src/settings/UISettingsDialogSpecific.h \
 	src/settings/UISettingsPage.h \
+	src/settings/UISettingsSelector.h \
 	src/widgets/UIAddDiskEncryptionPasswordDialog.h \
 	src/widgets/UIBootTable.h \
@@ -1037,5 +1038,4 @@
 	src/selector/graphics/details/UIGDetailsElements.cpp \
 	src/selector/graphics/details/UIGMachinePreview.cpp \
-	src/settings/UISettingsSelector.cpp \
 	src/settings/UISettingsSerializer.cpp \
 	src/settings/global/UIGlobalSettingsExtension.cpp \
@@ -1222,4 +1222,5 @@
 	src/settings/UISettingsDialogSpecific.cpp \
 	src/settings/UISettingsPage.cpp \
+	src/settings/UISettingsSelector.cpp \
 	src/widgets/UIAddDiskEncryptionPasswordDialog.cpp \
 	src/widgets/UIBootTable.cpp \
@@ -1365,4 +1366,5 @@
 	src/settings/UISettingsDialogSpecific.cpp \
 	src/settings/UISettingsPage.cpp \
+	src/settings/UISettingsSelector.cpp \
 	src/widgets/UIAddDiskEncryptionPasswordDialog.cpp \
 	src/widgets/UIBootTable.cpp \
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSelector.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSelector.cpp	(revision 72101)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSelector.cpp	(revision 72102)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2008-2017 Oracle Corporation
+ * Copyright (C) 2008-2018 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -816,3 +816,2 @@
 
 }
-
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSelector.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSelector.h	(revision 72101)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSelector.h	(revision 72102)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2008-2017 Oracle Corporation
+ * Copyright (C) 2008-2018 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -22,4 +22,7 @@
 #include <QObject>
 
+/* GUI includes: */
+#include "UILibraryDefs.h"
+
 /* Forward declarations: */
 class QAction;
@@ -29,6 +32,6 @@
 class QTreeWidgetItem;
 class QITreeWidget;
+class UISelectorActionItem;
 class UISelectorItem;
-class UISelectorActionItem;
 class UISettingsPage;
 class UIToolBar;
@@ -37,5 +40,5 @@
 /** QObject subclass providing settings dialog
   * with the means to switch between settings pages. */
-class UISettingsSelector : public QObject
+class SHARED_LIBRARY_STUFF UISettingsSelector : public QObject
 {
     Q_OBJECT;
@@ -51,5 +54,5 @@
     UISettingsSelector(QWidget *pParent = 0);
     /** Destructs settings selector. */
-    ~UISettingsSelector();
+    virtual ~UISettingsSelector() /* override */;
 
     /** Returns the widget selector operates on. */
@@ -124,5 +127,5 @@
   * with the means to switch between settings pages.
   * This one represented as tree-widget. */
-class UISettingsSelectorTreeView : public UISettingsSelector
+class SHARED_LIBRARY_STUFF UISettingsSelectorTreeView : public UISettingsSelector
 {
     Q_OBJECT;
@@ -133,5 +136,5 @@
     UISettingsSelectorTreeView(QWidget *pParent = 0);
     /** Destructs settings selector. */
-    ~UISettingsSelectorTreeView();
+    virtual ~UISettingsSelectorTreeView() /* override */;
 
     /** Returns the widget selector operates on. */
@@ -197,5 +200,5 @@
   * with the means to switch between settings pages.
   * This one represented as tab-widget. */
-class UISettingsSelectorToolBar : public UISettingsSelector
+class SHARED_LIBRARY_STUFF UISettingsSelectorToolBar : public UISettingsSelector
 {
     Q_OBJECT;
@@ -206,5 +209,5 @@
     UISettingsSelectorToolBar(QWidget *pParent = 0);
     /** Destructs settings selector. */
-    ~UISettingsSelectorToolBar();
+    virtual ~UISettingsSelectorToolBar() /* override */;
 
     /** Returns the widget selector operates on. */
@@ -275,4 +278,4 @@
 };
 
+
 #endif /* !___UISettingsSelector_h___ */
-