Index: /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 72104)
+++ /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 72105)
@@ -520,5 +520,4 @@
 	src/selector/graphics/details/UIGDetailsElements.h \
 	src/selector/graphics/details/UIGMachinePreview.h \
-	src/settings/UISettingsSerializer.h \
 	src/settings/global/UIGlobalSettingsExtension.h \
 	src/settings/global/UIGlobalSettingsGeneral.h \
@@ -664,4 +663,5 @@
 	src/settings/UISettingsPage.h \
 	src/settings/UISettingsSelector.h \
+	src/settings/UISettingsSerializer.h \
 	src/widgets/UIAddDiskEncryptionPasswordDialog.h \
 	src/widgets/UIBootTable.h \
@@ -781,4 +781,5 @@
 	src/settings/UISettingsPage.h \
 	src/settings/UISettingsSelector.h \
+	src/settings/UISettingsSerializer.h \
 	src/widgets/UIAddDiskEncryptionPasswordDialog.h \
 	src/widgets/UIBootTable.h \
@@ -1038,5 +1039,4 @@
 	src/selector/graphics/details/UIGDetailsElements.cpp \
 	src/selector/graphics/details/UIGMachinePreview.cpp \
-	src/settings/UISettingsSerializer.cpp \
 	src/settings/global/UIGlobalSettingsExtension.cpp \
 	src/settings/global/UIGlobalSettingsGeneral.cpp \
@@ -1223,4 +1223,5 @@
 	src/settings/UISettingsPage.cpp \
 	src/settings/UISettingsSelector.cpp \
+	src/settings/UISettingsSerializer.cpp \
 	src/widgets/UIAddDiskEncryptionPasswordDialog.cpp \
 	src/widgets/UIBootTable.cpp \
@@ -1367,4 +1368,5 @@
 	src/settings/UISettingsPage.cpp \
 	src/settings/UISettingsSelector.cpp \
+	src/settings/UISettingsSerializer.cpp \
 	src/widgets/UIAddDiskEncryptionPasswordDialog.cpp \
 	src/widgets/UIBootTable.cpp \
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSerializer.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSerializer.cpp	(revision 72104)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSerializer.cpp	(revision 72105)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2017 Oracle Corporation
+ * Copyright (C) 2006-2018 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -33,10 +33,15 @@
 #endif /* !VBOX_WITH_PRECOMPILED_HEADERS */
 
-UISettingsSerializer::UISettingsSerializer(QObject *pParent, SerializationDirection direction,
+
+/*********************************************************************************************************************************
+*   Class UISettingsSerializer implementation.                                                                                   *
+*********************************************************************************************************************************/
+
+UISettingsSerializer::UISettingsSerializer(QObject *pParent, SerializationDirection enmDirection,
                                            const QVariant &data, const UISettingsPageList &pages)
     : QThread(pParent)
-    , m_direction(direction)
+    , m_enmDirection(enmDirection)
     , m_data(data)
-    , m_fSavingComplete(m_direction == Load)
+    , m_fSavingComplete(m_enmDirection == Load)
     , m_iIdOfHighPriorityPage(-1)
 {
@@ -76,5 +81,5 @@
 
     /* If serializer saves settings: */
-    if (m_direction == Save)
+    if (m_enmDirection == Save)
     {
         /* We should update internal page cache first: */
@@ -96,5 +101,5 @@
 
     /* If serializer loads settings: */
-    if (m_direction == Load)
+    if (m_enmDirection == Load)
     {
         /* We should fetch internal page cache: */
@@ -115,5 +120,5 @@
 {
     /* If serializer saves settings: */
-    if (m_direction == Save)
+    if (m_enmDirection == Save)
     {
         /* We should flag GUI thread to unlock itself: */
@@ -159,7 +164,7 @@
         if (pPage->isEnabled())
         {
-            if (m_direction == Load)
+            if (m_enmDirection == Load)
                 pPage->loadToCacheFrom(m_data);
-            if (m_direction == Save)
+            if (m_enmDirection == Save)
                 pPage->saveFromCacheTo(m_data);
         }
@@ -175,5 +180,5 @@
         emit sigNotifyAboutPageProcessed(pPage->id());
         /* If serializer saves settings => wake up GUI thread: */
-        if (m_direction == Save)
+        if (m_enmDirection == Save)
             m_condition.wakeAll();
         /* Break further processing if page had failed: */
@@ -184,5 +189,5 @@
     emit sigNotifyAboutPagesProcessed();
     /* If serializer saves settings => wake up GUI thread: */
-    if (m_direction == Save)
+    if (m_enmDirection == Save)
         m_condition.wakeAll();
 
@@ -191,10 +196,15 @@
 }
 
-QString UISettingsSerializerProgress::m_strProgressDescriptionTemplate = QString("<compact elipsis=\"middle\">%1 (%2/%3)</compact>");
-
-UISettingsSerializerProgress::UISettingsSerializerProgress(QWidget *pParent, UISettingsSerializer::SerializationDirection direction,
+
+/*********************************************************************************************************************************
+*   Class UISettingsSerializerProgress implementation.                                                                           *
+*********************************************************************************************************************************/
+
+QString UISettingsSerializerProgress::s_strProgressDescriptionTemplate = QString("<compact elipsis=\"middle\">%1 (%2/%3)</compact>");
+
+UISettingsSerializerProgress::UISettingsSerializerProgress(QWidget *pParent, UISettingsSerializer::SerializationDirection enmDirection,
                                                            const QVariant &data, const UISettingsPageList &pages)
     : QIWithRetranslateUI<QIDialog>(pParent)
-    , m_direction(direction)
+    , m_enmDirection(enmDirection)
     , m_data(data)
     , m_pages(pages)
@@ -221,5 +231,5 @@
 }
 
-QVariant& UISettingsSerializerProgress::data()
+QVariant &UISettingsSerializerProgress::data()
 {
     AssertPtrReturn(m_pSerializer, m_data);
@@ -236,5 +246,5 @@
 
     /* Create serializer: */
-    m_pSerializer = new UISettingsSerializer(this, m_direction, m_data, m_pages);
+    m_pSerializer = new UISettingsSerializer(this, m_enmDirection, m_data, m_pages);
     AssertPtrReturnVoid(m_pSerializer);
     {
@@ -378,5 +388,5 @@
     m_pLabelSubOperationProgress->show();
     m_pBarSubOperationProgress->show();
-    m_pLabelSubOperationProgress->setText(m_strProgressDescriptionTemplate.arg(strOperation).arg(iOperation).arg(iOperations));
+    m_pLabelSubOperationProgress->setText(s_strProgressDescriptionTemplate.arg(strOperation).arg(iOperation).arg(iOperations));
     m_pBarSubOperationProgress->setValue(iPercent);
 }
@@ -390,3 +400,2 @@
     msgCenter().cannotSaveSettings(strErrorInfo, this);
 }
-
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSerializer.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSerializer.h	(revision 72104)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSerializer.h	(revision 72105)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2017 Oracle Corporation
+ * Copyright (C) 2006-2018 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -20,20 +20,28 @@
 
 /* Qt includes: */
+#include <QList>
+#include <QMap>
+#include <QMutex>
 #include <QThread>
 #include <QVariant>
 #include <QWaitCondition>
-#include <QMutex>
-#include <QList>
-#include <QMap>
 
 /* GUI includes: */
+#include "QIDialog.h"
 #include "QIWithRetranslateUI.h"
-#include "QIDialog.h"
 
 /* Forward declarations: */
+class QCloseEvent;
+class QLabel;
+class QMutex;
+class QObject;
+class QString;
+class QThread;
+class QProgressBar;
+class QVariant;
+class QWaitCondition;
+class QWidget;
+class QILabel;
 class UISettingsPage;
-class QProgressBar;
-class QILabel;
-class QLabel;
 
 /* Type definitions: */
@@ -41,7 +49,8 @@
 typedef QMap<int, UISettingsPage*> UISettingsPageMap;
 
+
 /** QThread reimplementation used for
   * loading/saving settings in async mode. */
-class UISettingsSerializer : public QThread
+class SHARED_LIBRARY_STUFF UISettingsSerializer : public QThread
 {
     Q_OBJECT;
@@ -62,13 +71,13 @@
 
     /** Notifies listeners about particular operation progress change.
-      * @param iOperations  holds the number of operations CProgress have,
-      * @param strOperation holds the description of the current CProgress operation,
-      * @param iOperation   holds the index of the current CProgress operation,
-      * @param iPercent     holds the percentage of the current CProgress operation. */
+      * @param  iOperations   Brings the number of operations CProgress have.
+      * @param  strOperation  Brings the description of the current CProgress operation.
+      * @param  iOperation    Brings the index of the current CProgress operation.
+      * @param  iPercent      Brings the percentage of the current CProgress operation. */
     void sigOperationProgressChange(ulong iOperations, QString strOperation,
                                     ulong iOperation, ulong iPercent);
 
     /** Notifies listeners about particular COM error.
-      * @param strErrorInfo holds the details of the error happened. */
+      * @param  strErrorInfo  Brings the details of the error happened. */
     void sigOperationProgressError(QString strErrorInfo);
 
@@ -78,20 +87,19 @@
     enum SerializationDirection { Load, Save };
 
-    /** Constructor.
-      * @param pParent   being passed to the base-class,
-      * @param direction determines the load/save direction,
-      * @param data      contains the wrapper(s) to load/save the data from/to,
-      * @param pages     contains the page(s) to load/save the data to/from. */
-    UISettingsSerializer(QObject *pParent, SerializationDirection direction,
+    /** Constructs serializer passing @a pParent to the base-class.
+      * @param  enmDirection  Brings the load/save direction.
+      * @param  data          Brings the wrapper(s) to load/save the data from/to.
+      * @param  pages         Brings the page(s) to load/save the data to/from. */
+    UISettingsSerializer(QObject *pParent, SerializationDirection enmDirection,
                          const QVariant &data, const UISettingsPageList &pages);
 
-    /** Destructor. */
-    ~UISettingsSerializer();
+    /** Destructs serializer. */
+    virtual ~UISettingsSerializer() /* override */;
 
     /** Returns the load/save direction. */
-    SerializationDirection direction() const { return m_direction; }
+    SerializationDirection direction() const { return m_enmDirection; }
 
     /** Returns the instance of wrapper(s) to load/save the data from/to. */
-    QVariant& data() { return m_data; }
+    QVariant &data() { return m_data; }
 
     /** Returns the count of the page(s) to load/save the data to/from. */
@@ -120,26 +128,27 @@
 
     /** Holds the load/save direction. */
-    const SerializationDirection m_direction;
+    const SerializationDirection  m_enmDirection;
 
     /** Holds the wrapper(s) to load/save the data from/to. */
-    QVariant m_data;
+    QVariant           m_data;
     /** Holds the page(s) to load/save the data to/from. */
-    UISettingsPageMap m_pages;
+    UISettingsPageMap  m_pages;
     /** Holds the page(s) to load/save the data to/from for which that task was done. */
-    UISettingsPageMap m_pagesDone;
+    UISettingsPageMap  m_pagesDone;
 
     /** Holds whether the save was complete. */
-    bool m_fSavingComplete;
+    bool            m_fSavingComplete;
     /** Holds the ID of the high priority page. */
-    int m_iIdOfHighPriorityPage;
+    int             m_iIdOfHighPriorityPage;
     /** Holds the synchronization mutex. */
-    QMutex m_mutex;
+    QMutex          m_mutex;
     /** Holds the synchronization condition. */
-    QWaitCondition m_condition;
+    QWaitCondition  m_condition;
 };
+
 
 /** QIDialog reimplementation used to
   * reflect the settings serialization operation. */
-class UISettingsSerializerProgress : public QIWithRetranslateUI<QIDialog>
+class SHARED_LIBRARY_STUFF UISettingsSerializerProgress : public QIWithRetranslateUI<QIDialog>
 {
     Q_OBJECT;
@@ -152,10 +161,9 @@
 public:
 
-    /** Constructor.
-      * @param pParent   being passed to the base-class,
-      * @param direction determines the load/save direction,
-      * @param data      contains the wrapper(s) to load/save the data from/to,
-      * @param pages     contains the page(s) to load/save the data to/from. */
-    UISettingsSerializerProgress(QWidget *pParent, UISettingsSerializer::SerializationDirection direction,
+    /** Constructs serializer passing @a pParent to the base-class.
+      * @param  enmDirection  Brings the load/save direction.
+      * @param  data          Brings the wrapper(s) to load/save the data from/to.
+      * @param  pages         Brings the page(s) to load/save the data to/from. */
+    UISettingsSerializerProgress(QWidget *pParent, UISettingsSerializer::SerializationDirection enmDirection,
                                  const QVariant &data, const UISettingsPageList &pages);
 
@@ -164,5 +172,5 @@
 
     /** Returns the instance of wrapper(s) to load/save the data from/to. */
-    QVariant& data();
+    QVariant &data();
 
     /** Returns whether there were no errors. */
@@ -192,13 +200,13 @@
 
     /** Handles particular operation progress change.
-      * @param iOperations  holds the number of operations CProgress have,
-      * @param strOperation holds the description of the current CProgress operation,
-      * @param iOperation   holds the index of the current CProgress operation,
-      * @param iPercent     holds the percentage of the current CProgress operation. */
+      * @param  iOperations   Brings the number of operations CProgress have.
+      * @param  strOperation  Brings the description of the current CProgress operation.
+      * @param  iOperation    Brings the index of the current CProgress operation.
+      * @param  iPercent      Brings the percentage of the current CProgress operation. */
     void sltHandleOperationProgressChange(ulong iOperations, QString strOperation,
                                           ulong iOperation, ulong iPercent);
 
     /** Handles particular COM error.
-      * @param strErrorInfo holds the details of the error happened. */
+      * @param  strErrorInfo  Brings the details of the error happened. */
     void sltHandleOperationProgressError(QString strErrorInfo);
 
@@ -206,10 +214,10 @@
 
     /** Holds the load/save direction. */
-    const UISettingsSerializer::SerializationDirection m_direction;
+    const UISettingsSerializer::SerializationDirection  m_enmDirection;
 
     /** Holds the wrapper(s) to load/save the data from/to. */
-    QVariant m_data;
+    QVariant            m_data;
     /** Holds the page(s) to load/save the data to/from. */
-    UISettingsPageList m_pages;
+    UISettingsPageList  m_pages;
 
     /** Holds the pointer to the thread loading/saving settings in async mode. */
@@ -217,19 +225,20 @@
 
     /** Holds the operation progress label. */
-    QLabel *m_pLabelOperationProgress;
+    QLabel       *m_pLabelOperationProgress;
     /** Holds the operation progress bar. */
     QProgressBar *m_pBarOperationProgress;
 
     /** Holds the sub-operation progress label. */
-    QILabel *m_pLabelSubOperationProgress;
+    QILabel      *m_pLabelSubOperationProgress;
     /** Holds the sub-operation progress bar. */
     QProgressBar *m_pBarSubOperationProgress;
 
     /** Holds whether there were no errors. */
-    bool m_fClean;
+    bool  m_fClean;
 
     /** Holds the template for the sub-operation progress label. */
-    static QString m_strProgressDescriptionTemplate;
+    static QString  s_strProgressDescriptionTemplate;
 };
 
+
 #endif /* !___UISettingsSerializer_h___ */