Index: /trunk/Config.kmk
===================================================================
--- /trunk/Config.kmk	(revision 72151)
+++ /trunk/Config.kmk	(revision 72152)
@@ -782,6 +782,4 @@
 # Enable to compile with OpenSSL 1.0 (only relevant for Windows, see src/VBox/Runtime/Makefile.kmk)
 #VBOX_WITH_OPENSSL_PRE_1_1 = 1
-# Enable Seamless mode
-VBOX_X11_SEAMLESS_GUEST = 1
 # Enables all the doxgen bits.
 VBOX_WITH_ALL_DOXYGEN_TARGETS = 1
Index: /trunk/src/VBox/Additions/x11/VBoxClient/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Additions/x11/VBoxClient/Makefile.kmk	(revision 72151)
+++ /trunk/src/VBox/Additions/x11/VBoxClient/Makefile.kmk	(revision 72152)
@@ -32,11 +32,15 @@
 VBoxClient_INCS = $(VBOX_GRAPHICS_INCS)
 VBoxClient_SOURCES = \
-	main.cpp
-VBoxClient_SOURCES += \
+	main.cpp \
   	$(PATH_ROOT)/src/VBox/GuestHost/SharedClipboard/clipboard-helper.cpp \
   	$(PATH_ROOT)/src/VBox/GuestHost/SharedClipboard/x11-clipboard.cpp \
 	clipboard.cpp \
 	display-svga.cpp \
-	display-svga-x11.cpp
+	display-svga-x11.cpp \
+	seamless.cpp \
+	seamless-x11.cpp \
+	display.cpp \
+	hostversion.cpp \
+	check3d.cpp
 VBoxClient_SOURCES.linux = \
 	chk_stubs.c
@@ -50,7 +54,5 @@
 	dl
 VBoxClient_LIBS = \
-	X11 \
-	Xrandr \
-	Xt
+	X11 Xrandr Xt Xext Xmu
 
 # XXX: -L comes from the template, but not rpath
@@ -79,15 +81,4 @@
 endif
 
-ifdef VBOX_X11_SEAMLESS_GUEST
- VBoxClient_DEFS += SEAMLESS_GUEST DYNAMIC_RESIZE
- VBoxClient_SOURCES += \
-	seamless.cpp \
-	seamless-x11.cpp \
-	display.cpp \
-	hostversion.cpp \
-	check3d.cpp
- VBoxClient_LIBS += \
-	Xext Xmu
-endif
 ifdef VBOX_WITH_GUEST_PROPS
  VBoxClient_DEFS += VBOX_WITH_GUEST_PROPS
@@ -103,7 +94,6 @@
 endif
 
-ifdef VBOX_X11_SEAMLESS_GUEST
- if defined(VBOX_WITH_TESTCASES) && !defined(VBOX_ONLY_ADDITIONS) && !defined(VBOX_ONLY_SDK)
-  if1of ($(KBUILD_TARGET), freebsd linux netbsd openbsd solaris)
+if defined(VBOX_WITH_TESTCASES) && !defined(VBOX_ONLY_ADDITIONS) && !defined(VBOX_ONLY_SDK)
+ if1of ($(KBUILD_TARGET), freebsd linux netbsd openbsd solaris)
 
 # Set this in LocalConfig.kmk if you are working on the X11 clipboard service
@@ -111,38 +101,37 @@
 #       OTHERS += $(tstSeamlessX11-auto_0_OUTDIR)/tstSeamlessX11-auto.run
 
-   PROGRAMS += tstSeamlessX11-auto
-   tstSeamlessX11-auto_TEMPLATE = VBOXR3TSTEXE
-   tstSeamlessX11-auto_SOURCES = \
-           testcase/tstSeamlessX11-auto.cpp \
-           seamless-x11.cpp
-   tstSeamlessX11-auto_DEFS = TESTCASE
-   tstSeamlessX11-auto_LIBS = \
-           $(LIB_RUNTIME)
+  PROGRAMS += tstSeamlessX11-auto
+  tstSeamlessX11-auto_TEMPLATE = VBOXR3TSTEXE
+  tstSeamlessX11-auto_SOURCES = \
+          testcase/tstSeamlessX11-auto.cpp \
+          seamless-x11.cpp
+  tstSeamlessX11-auto_DEFS = TESTCASE
+  tstSeamlessX11-auto_LIBS = \
+          $(LIB_RUNTIME)
 
-   TESTING  += $(tstSeamlessX11-auto_0_OUTDIR)/tstSeamlessX11-auto
+  TESTING  += $(tstSeamlessX11-auto_0_OUTDIR)/tstSeamlessX11-auto
 $$(tstSeamlessX11-auto_0_OUTDIR)/tstSeamlessX11-auto.run: \
-        $$(tstSeamlessX11-auto_1_STAGE_TARGET)
+       $$(tstSeamlessX11-auto_1_STAGE_TARGET)
 	export VBOX_LOG_DEST=nofile; $(tstSeamlessX11-auto_1_STAGE_TARGET) quiet
 	$(QUIET)$(APPEND) -t "$@" "done"
 
-   #
-   # Additional testcase designed to be run manually, which initiates and starts the Linux
-   # guest client part of the seamless additions in the host, faking seamless events from
-   # the host and writing information about guest events to standard output.
-   #
-   PROGRAMS += tstSeamlessX11
-   tstSeamlessX11_TEMPLATE = VBOXR3TSTEXE
-   tstSeamlessX11_SOURCES = \
-           testcase/tstSeamlessX11.cpp \
-           seamless.cpp \
-           seamless-x11.cpp
-   tstSeamlessX11_LIBPATH = \
-           $(VBOX_LIBPATH_X11)
-   tstSeamlessX11_LIBS = \
-           $(LIB_RUNTIME) \
-           Xext \
-           Xmu \
-           X11
-  endif
+  #
+  # Additional testcase designed to be run manually, which initiates and starts the Linux
+  # guest client part of the seamless additions in the host, faking seamless events from
+  # the host and writing information about guest events to standard output.
+  #
+  PROGRAMS += tstSeamlessX11
+  tstSeamlessX11_TEMPLATE = VBOXR3TSTEXE
+  tstSeamlessX11_SOURCES = \
+          testcase/tstSeamlessX11.cpp \
+          seamless.cpp \
+          seamless-x11.cpp
+  tstSeamlessX11_LIBPATH = \
+          $(VBOX_LIBPATH_X11)
+  tstSeamlessX11_LIBS = \
+          $(LIB_RUNTIME) \
+          Xext \
+          Xmu \
+          X11
  endif
 endif